import numpy as np

##---------------------------------------------------------------------------------------------------
class BoundingBox:
    ##-----------------------------------------------------------------------------------------------
    def __init__(self, min, max):
        self.min = min
        self.max = max
        
    ##-----------------------------------------------------------------------------------------------  
    def enlarge(self, min_point, max_point):
        self.enlarge_point(min_point)
        self.enlarge_point(max_point)    
        
    ##-----------------------------------------------------------------------------------------------   
    def enlarge_point(self, pt):
        self.min = np.minimum(self.min, pt).tolist()
        self.max = np.maximum(self.max, pt).tolist() 
        
    ##-----------------------------------------------------------------------------------------------
    def to_dict(self):
        return {
            "max": self.max,
            "min": self.min
        }  
   
    ##-----------------------------------------------------------------------------------------------
    def is_valid(self):
        return (
            (self.min[0] < self.max[0] or np.isclose(self.min[0], self.max[0]))
            and (self.min[1] < self.max[1] or np.isclose(self.min[1], self.max[1]))
            and (self.min[2] < self.max[2] or np.isclose(self.min[2], self.max[2]))
        )
        