import struct 


##---------------------------------------------------------------------------------------------------
class MeshPayload:
    ##-----------------------------------------------------------------------------------------------
    def __init__(self):
        self.byte_data = bytearray()
        
    ##-----------------------------------------------------------------------------------------------       
    def write_submesh_in_mesh_payload(self, submesh):
        self.write_indices(submesh)
        
        self.write_positions(submesh) 
        
        if(submesh.has_normals()):
            self.write_normals(submesh)
        
    ##-----------------------------------------------------------------------------------------------
    def write_indices(self, submesh):
        self.write_indices_impl(submesh)
                   
    ##-----------------------------------------------------------------------------------------------      
    def write_indices_impl(self, submesh):
        for i in range(submesh.num_indices):
            face = submesh.indices[i]
            for component in face:
                self.byte_data.extend(struct.pack('<h', component))
       
    ##-----------------------------------------------------------------------------------------------
    def write_positions(self, submesh):
        for vertex in submesh.positions:
            for component in vertex:
                self.byte_data.extend(struct.pack('f', component))
            
    ##-----------------------------------------------------------------------------------------------
    def write_normals(self, submesh):
        for normal in submesh.normals:
            for component in normal:
                self.byte_data.extend(struct.pack('f', component))
 